define(['ojs/ojcore', 'knockout',    'jquery','ojs/ojknockout','ojs/ojmodel', 'promise',  'ojs/ojtable'],

        function(oj, ko,$)
        {

            function hrmViewModel() {
                var self = this;

                self.serviceURL = 'https://data-api-lucasjellema.apaas.em2.oraclecloud.com';

                self.DeptCol = ko.observable(); // DeptCol is an observable so when its data is in (from the REST service), the datasource is triggered
                self.datasource = ko.observable(); // datasource is an observable so when it is triggered/refreshed, the table component is triggered
				
                function parseRESTDBDepartment(response) {
                   return {DepartmentId: response['DEPARTMENT_ID'], DepartmentName: response['DEPARTMENT_NAME'], Location: "Zoetermeer"};
                }
				
	                // think of this as a single record in the DB, or a single row in your table
                var Department = oj.Model.extend({
                    parse: parseRESTDBDepartment,
                    idAttribute: 'DepartmentId'
                });

                // this defines our collection and what models it will hold
                var DeptCollection = oj.Collection.extend({
                    url: self.serviceURL+"/departments" ,
                    model: new Department(),
                    comparator: "DepartmentId"
                });

                self.DeptCol(new DeptCollection());
                self.datasource(new oj.CollectionTableDataSource(self.DeptCol()));

				                
                self.EmpCol = ko.observable(); // EmpCol is an observable so when its data is in (from the REST service), the datasource is triggered
                self.empDatasource = ko.observable(); // datasource is an observable so when it is triggered/refreshed, the table component is triggered
				
                function parseRESTDBEmployee(response) {
                   return {EmployeeId: response['EMPLOYEE_ID'], Name: response['FIRST_NAME']+" "+response['LAST_NAME'], Job: response['JOB_ID']};
                }
				
	                // think of this as a single record in the DB, or a single row in your table
                var Employee = oj.Model.extend({
                    parse: parseRESTDBEmployee,
                    idAttribute: 'EmployeeId'
                });

                // this defines our collection and what models it will hold
                var EmpCollection = oj.Collection.extend({
                    model: new Employee(),
                    comparator: "EmployeeId"
                    });

				self.refreshEmployees = function (departmentId) {
					if (departmentId !=null) {
                      self.EmpCol(new EmpCollection());
        			  self.EmpCol().url = self.serviceURL+"/departments/"+departmentId;
	                  self.empDatasource(new oj.CollectionTableDataSource(self.EmpCol()));
					} else {
                        self.empDatasource(null);
					}
                }
				// initial fetch of employees
				// self.refreshEmployees(100);
				
				// resource: https://blogs.oracle.com/geertjan/entry/selecting_a_row_in_oracle1 
	            self.currentRowListener = function (event, data) {  console.log('before current row listener');   };			
                self.selectionListener = function (event, data) 
				{ var tableId = data.currentTarget.id;
    		      var key = currentSelection(tableId);
	              event.refreshEmployees(key);		
				};
                self.sortListener = function (event, data) {console.log('sort  listener');};
            }
			
			function myselectionListener(event, data) // event contains a reference to the HRM viewmodel
            {
			  var obj = data.currentTarget;
			  var tableId = obj.id;
    		  var key = currentSelection(tableId);
	          event.refreshEmployees(key);		
            }
	
	// find the currently selected key - using the knowledge that single row selection is configured on the table
    function currentSelection(tableId)
    {
       var selectionObj = $("#"+tableId).ojTable("option", "selection");	
 	   return selectionObj[0]?selectionObj[0].startKey.row:null;
    };
			
			
			function beforeCurrentRowListener(event, data)
    {
        var newCurrentRow = data.currentRow;
        var oldCurrentRow = data.previousCurrentRow;
        var eventTxt = "Triggered ojbeforecurrentrow event: \npreviousCurrentRow: ";
        if (!oldCurrentRow)
        {
            eventTxt = eventTxt + 'null \n'; 
        }
        else
        {
            eventTxt = eventTxt + "{rowIndex: " + oldCurrentRow['rowIndex'] + " rowKey: " +  oldCurrentRow['rowKey'] + "} \n";
        }
        
        if (!newCurrentRow)
        {
            eventTxt = eventTxt + "currentRow: null \n";
        }
        else
        {
            eventTxt = eventTxt + "currentRow: {rowIndex: " + newCurrentRow['rowIndex'] + " rowKey: " +  newCurrentRow['rowKey'] + "} \n";
        }

        console.log(eventTxt + "\n" );
		console.log("Newly selected Department Id : "+newCurrentRow['rowKey']);
		
    
	}
    
    
    function sortListener(event, data)
    {
	console.log('sort');
      /*  var eventTxt = "Triggered ojsort event: \n";
        eventTxt = eventTxt + "{header: " + data['header'] + " direction: " +  data['direction'] + "} \n";

        var currentTxt = $('#eventLog').val();
        console.log(eventTxt + "\n" + currentTxt);
		*/
    }

	
			$(document).ready
  (
    function()
    {
      console.log('ready - apply selection listener');

       //$('#table').on('ojoptionchange', selectionListener);	  
//	     $('#dept-table').on('ojoptionchange', selectionListener);
		 //$('#dept-table').on('ojbeforecurrentrow', beforeCurrentRowListener);
//        $('#dept-table').on('ojsort', sortListener);
    }
  );
			
            return hrmViewModel;
			
			
        });
